require_relative('lib/thermostat.rb')
require_relative('lib/led.rb')
require_relative('lib/unit.rb')

class ThermostatApplication

    def initialize

        thermostat = Thermostat.new(ARGV[0],ARGV[1],ARGV[2])
        led = Led.new(ARGV[0],ARGV[1],ARGV[2])
        unit = Unitconverter.new(ARGV[0], ARGV[1], ARGV[2], ARGV[3])
        
        if ARGV.length != 4
            puts "We need exactly four arguments"
            exit
        end

        puts "current temp: " + ARGV[0] + "°" + ARGV[3] 
        puts "wanted temp: " + ARGV[1] + "°" + ARGV[3]
        puts "range: " + ARGV[2] + "°" + ARGV[3]

       
        #cooling and heating true or false
        puts "cooling: #{thermostat.cooling?}"
        puts "heating: #{thermostat.heating?}"
        
        #color of led
        puts "The led is: #{led.colorled}"
        
        #unitconverter units
        puts "#{unit.convertingunit}"
        end

ThermostatApplication.new
    
end