require_relative('thermostat.rb')

class Unitconverter

    TOFAHRENHEITFACTOR1 = 1.8
    TOFAHRENHEITFACTOR2 = 32  
    
    TOKELVIN1 = 273.15
    TOKELVIN2 = 459.67
    TOKELVIN3 = 0.55555555

    DECIMALS = 2

    def initialize (currentValue, wantedValue, range = 0.5, unit)

        @currentValue = currentValue.to_i
        @wantedValue = wantedValue.to_i
        @range = range.to_i
        @unit = unit
    end


    def convertingunit
            if @unit == "C"
                currentfahrenheit = (@currentValue + @range) * TOFAHRENHEITFACTOR1 + TOFAHRENHEITFACTOR2
                wantedfahrenheit = @wantedValue * TOFAHRENHEITFACTOR1 + TOFAHRENHEITFACTOR2
                
                currentkelvin = (@currentValue + @range) + TOKELVIN1
                wantedkelvin = @wantedValue + TOKELVIN1

                print "Current Temp Fahrenheit = ", currentfahrenheit.round(DECIMALS), " °F", "\n"
                print "Wanted Temp Fahrenheit = ", wantedfahrenheit.round(DECIMALS), " °F", "\n"
                print "Current Temp Kelvin = ", currentkelvin.round(DECIMALS), " K", "\n"
                print "wanted Temp Kelvin = ", wantedkelvin.round(DECIMALS), " K", "\n"
            
            elsif @unit == "F"
                currentcelsius = (@currentValue + @range - TOFAHRENHEITFACTOR2) / TOFAHRENHEITFACTOR1
                wantedcelsius = (@wantedValue - TOFAHRENHEITFACTOR2) / TOFAHRENHEITFACTOR1

                currentkelvin = (@currentValue + @range + TOKELVIN2) * TOKELVIN3
                wantedkelvin = (@wantedValue + TOKELVIN2) * TOKELVIN3
                
                print "Current Temp Celsius = ", currentcelsius.round(DECIMALS), " °C", "\n"
                print "Wanted Temp Celsius = ", wantedcelsius.round(DECIMALS), " °C", "\n"
                print "Current Temp Kelvin = ", currentkelvin.round(DECIMALS), " K", "\n"
                print "Wanted Temp Kelvin = ", wantedkelvin.round(DECIMALS), " K", "\n"
                
            elsif @unit == "K"
                currentcelsius = @currentValue + @range - TOKELVIN1
                wantedcelsius = @wantedValue - TOKELVIN1

                curAndRange = @currentValue + @range
                currentfahrenheit = (curAndRange / TOKELVIN3) - TOKELVIN2
                wantedfahrenheit = (@wantedValue / TOKELVIN3) - TOKELVIN2

                print "Current Temp Celsius = ", currentcelsius.round(DECIMALS), " °C", "\n"
                print "Wanted Temp Celsius = ", wantedcelsius.round(DECIMALS), " °C", "\n"
                print "Current Temp Fahrenheit = ", currentfahrenheit.round(DECIMALS), " °F", "\n"
                print "Wanted Temp Fahrenheit = ", wantedfahrenheit.round(DECIMALS), " °F", "\n"
                
            else
                print "this unit doesn't exist!"
            end
    end
end
