class Thermostat

    
    def initialize (currentValue, wantedValue, range = 0.5)

    @currentValue = currentValue
    @wantedValue = wantedValue
    @range = range

    end

    def current
        @currentValue
    end

    def wanted 
        @wantedValue
    end

    def range
        @range
    end
    
    def heating?
        @wantedValue > (@currentValue + @range)
    end

    def cooling?
        @wantedValue < (@currentValue + @range)
    end
end